.\"	$NetBSD: iopaau.4,v 1.3 2002/11/23 17:36:28 thorpej Exp $
.\"
.\" Copyright (c) 2002 Wasabi Systems, Inc.
.\" All rights reserved.
.\"
.\" Written by Jason R. Thorpe for Wasabi Systems, Inc.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgement:
.\"	This product includes software developed for the NetBSD Project by
.\"	Wasabi Systems, Inc.
.\" 4. The name of Wasabi Systems, Inc. may not be used to endorse
.\"    or promote products derived from this software without specific prior
.\"    written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY WASABI SYSTEMS, INC. ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
.\" TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
.\" PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL WASABI SYSTEMS, INC
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd August 2, 2002
.Dt IOPAAU 4 evbarm
.Os
.Sh NAME
.Nm iopaau
.Nd Intel I/O Processor Application Accelerator Unit
.Sh SYNOPSIS
.Cd iopxs* at mainbus?
.Cd iopaau* at iopxs?
.Sh DESCRIPTION
The Application Accelerator Unit, or AAU, provides hardware-assisted
support for performing block fills on a region of memory, XOR of
multiple regions of memory
.Pq parity computation ,
and parity verification.
.Pp
The
.Nm
driver supports the Application Accelerator Units on the following
Intel I/O Processors:
.Bl -bullet
.\" .It
.\" Intel i80312 Companion I/O
.\" .Pq IOP310
.It
Intel i80321 I/O Processor
.El
.Pp
The
.Nm
driver provides a back-end to the
.Xr dmover 9
interface, and supports the following
.Xr dmover 9
functions:
.Bl -tag -width "fill8XX"
.It zero
Zero a region of memory
.It fill8
Fill a region of memory with an 8-bit value
.It copy
Copy a region of memory
.It xor2
Perform an XOR of 2 input streams
.It xor3
Perform an XOR of 3 input streams
.It xor4
Perform an XOR of 4 input streams
.It xor5
Perform an XOR of 5 input streams
.It xor6
Perform an XOR of 6 input streams
.It xor7
Perform an XOR of 7 input streams
.It xor8
Perform an XOR of 8 input streams
.El
.Sh SEE ALSO
.Xr dmover 9
.Sh HISTORY
The
.Nm
device first appeared in
.Nx 2.0 .
.Sh AUTHORS
The
.Nm
driver was written by
.An Jason R. Thorpe Aq thorpej@wasabisystems.com
and contributed by Wasabi Systems, Inc.
.Sh BUGS
Due to limitations in how scatter-gather is done by the AAU hardware,
a given DMA segment must be the same length for the output stream and
each input stream.  The easiest way to achieve this is to ensure that
all streams used in an AAU operation begin at the same offset into a
page.
